#include <iostream>
#include <cstdio>
#include <math.h>
#include <cassert>
#include <vector>

using namespace std;

const int maxn = 1 << 17;

int n;
int x[maxn], y[maxn];
double dp[maxn];

double d(int i, int j) {
    return sqrt(1.0 * (x[i] - x[j]) * (x[i] - x[j]) + 1.0 * (y[i] - y[j]) * (y[i] - y[j]));
}

int main() {
    freopen("icebergs.in", "r", stdin);
    freopen("icebergs.out", "w", stdout);

    cin >> n;
    for (int i = 0; i < n; i++) cin >> x[i] >> y[i];
    for (int i = 1; i < n; i++) {
        dp[i] = 1e20;
    }
    dp[0] = 0;
    vector<int> v(1, 0);
    for (int i = 1; i < n; i++) {
        dp[i] = 1e20;
        while (!v.empty()) {
            dp[i] = min(dp[i], max(dp[v.back()], d(i, v.back())));
            if (y[v.back()] > y[i]) break;
            v.pop_back();
        }
        v.push_back(i);
    }
    cout.precision(10);
    cout << fixed;
    cout << dp[n - 1] << endl;  

    return 0;
}